package com.zilber.boot.intelligencesite.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sun.org.apache.regexp.internal.RE;
import com.zilber.boot.intelligencesite.entity.IProgress;
import com.zilber.boot.intelligencesite.entity.IProgressNew;
import com.zilber.boot.intelligencesite.mapper.IProgressMapper;
import com.zilber.boot.intelligencesite.mapper.IProgressNewMapper;
import com.zilber.boot.intelligencesite.service.IIProgressNewService;
import com.zilber.boot.intelligencesite.service.IIProgressService;
import com.zilber.boot.utils.AjaxResult;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 进度跟踪表 服务实现类
 * </p>
 *
 * @author lsc
 * @since 2025-05-06
 */
@Service
public class IProgressNewServiceImpl extends ServiceImpl<IProgressNewMapper, IProgressNew> implements IIProgressNewService {


    @Resource
    private IProgressNewMapper iProgressNewMapper;

    @Override
    public AjaxResult add(IProgressNew iProgressNew) {
        //查询填报日期下的当日进度
        IProgressNew ip=iProgressNewMapper.queryByDate(iProgressNew.getPlanId(),iProgressNew.getProcessDate());
        if(ObjectUtils.isEmpty(ip)){
            List<IProgressNew> list=iProgressNewMapper.queryList(new IProgress().setPlanId(iProgressNew.getPlanId()));
            long total = list.stream().mapToLong(IProgressNew::getDayProgress).sum();
            if(iProgressNew.getDayProgress()+total>100){
                return AjaxResult.error("已超出最大值，最大值应为"+ (100 - total));
            }
            IProgressNew iProgressNew1=new IProgressNew();
            iProgressNew1.setPlanId(iProgressNew.getPlanId());
            iProgressNew1.setDayProgress(iProgressNew.getDayProgress());
            iProgressNew1.setCreateTime(new Date());
            iProgressNew1.setProcessDate(iProgressNew.getProcessDate());
          return AjaxResult.success(iProgressNewMapper.insert(iProgressNew1)) ;
        }else{
            List<IProgressNew> list=iProgressNewMapper.queryList(new IProgress().setPlanId(iProgressNew.getPlanId()));
            long total = list.stream().mapToLong(IProgressNew::getDayProgress).sum();
            if(iProgressNew.getDayProgress()+total>100){
                return AjaxResult.error("已超出最大值，最大值应为"+ (100 - total));
            }
            ip.setDayProgress(ip.getDayProgress()+iProgressNew.getDayProgress());
            return AjaxResult.success(iProgressNewMapper.updateById(ip));
        }
    }
}
